Option Explicit
Option Strict

Imports System
Imports System.Data
Imports System.Data.SQLClient
Imports System.Configuration

namespace projectpal.bo


Public Class boStaff

  public function Authenticate (email as string, password as string) as boolean
  
   	dim myDSN as String = ConfigurationSettings.AppSettings("ProjectPalDSN")
	dim mySQL as String = "Select count(*) from dbStaff where email = '" + email + "' and password = '" + password + "'"
	dim mySQLReader as SqlDataReader
	dim myConn As new SQLConnection(myDSN)
	dim mySQLCommand as new SqlCommand(mySQL, myConn)

	myConn.Open()
	mySQLReader = mySQLCommand.ExecuteReader()

    while (mySQLReader.Read()) 
       return( not (mySQLReader.GetInt32(0) = 0) )
    end while
	
	mySQLReader.Close
	myConn.Close

	Return ( False )
  
  end function

 

 public function isProjectStaff (email as string) as boolean
  
   	dim myDSN as String = ConfigurationSettings.AppSettings("ProjectPalDSN")
	dim mySQL as String = "Select count(*) from vwProjectsStaff where email = '" + email + "'"
	dim mySQLReader as SqlDataReader
	dim myConn As new SQLConnection(myDSN)
	dim mySQLCommand as new SqlCommand(mySQL, myConn)

	myConn.Open()
	mySQLReader = mySQLCommand.ExecuteReader()

    while (mySQLReader.Read()) 
       return( not (mySQLReader.GetInt32(0) = 0) )
    end while
	
	mySQLReader.Close
	myConn.Close

	Return ( False )
  
  end function

 public function isPM (email as string) as boolean
  
   	dim myDSN as String = ConfigurationSettings.AppSettings("ProjectPalDSN")
	dim mySQL as String = "Select count(*) from vwProjectsPM where email = '" + email + "'"
	dim mySQLReader as SqlDataReader
	dim myConn As new SQLConnection(myDSN)
	dim mySQLCommand as new SqlCommand(mySQL, myConn)

	myConn.Open()
	mySQLReader = mySQLCommand.ExecuteReader()

    while (mySQLReader.Read()) 
       return( not (mySQLReader.GetInt32(0) = 0) )
    end while
	
	mySQLReader.Close
	myConn.Close

	Return ( false )
  
  end function


  public sub Create (staffData as structStaff) 
  
	dim myDSN As String = ConfigurationSettings.AppSettings("ProjectPalDSN")
	dim myConn As new SqlConnection(myDSN)
	dim myCommand As SqlCommand
	dim myParm As SqlParameter
	dim myStaff AS new projectpal.bo.boStaff()

		myConn.Open()

		myCommand = New SqlCommand("spCreateStaff", myConn)
		myCommand.CommandType = CommandType.StoredProcedure
		myParm = myCommand.Parameters.Add("@staffdata", SqlDbType.varchar, 250)
		myParm.Value =  staffData.toinsertstring()

		myParm  = myCommand.Parameters.Add("@staffid", SqlDbType.int)
		myParm.Direction = ParameterDirection.Output

		myCommand.ExecuteNonQuery()
	
		myConn.Close

  end sub



  public function Detail (email as string) as structStaff
  
  	dim myDSN as String = ConfigurationSettings.AppSettings("ProjectPalDSN")
	dim mySQLReader as SqlDataReader
	dim myConn As new SQLConnection(myDSN)
	dim mySQLCommand as new SQLCommand("spGetStaffDetail", myConn)
	dim myStruct as new structStaff()

	mySQLCommand.CommandType = CommandType.StoredProcedure
	mySQLCommand.Parameters.Add(New SqlParameter("@email", SqlDbType.varchar))
    mySQLCommand.Parameters("@email").Value = email

	myConn.Open()
	mySQLReader = mySQLCommand.ExecuteReader()

    while (mySQLReader.Read()) 
	  myStruct.id = mySQLReader.GetInt32(0)
      myStruct.firstname = mySQLReader.GetString(1)
      myStruct.lastname = mySQLReader.GetString(2)
      myStruct.email = mySQLReader.GetString(3)
      myStruct.password = mySQLReader.GetString(4)
      myStruct.isPM = mySQLReader.GetInt32(5)
    end while
	
	mySQLReader.Close
	myConn.Close

	Return ( myStruct )
  
  end function


  public function GetStaff () as DataSet
  
 	dim myDataset as new Dataset
	dim myConn As new SQLConnection(ConfigurationSettings.AppSettings("ProjectPalDSN"))
	dim mySQLAdapter as new SQLDataAdapter("spGetStaff", myConn)

	mySQLAdapter.SelectCommand.CommandType = CommandType.StoredProcedure

    mySQLAdapter.Fill(myDataSet, "staff")
	
	Return myDataSet
  
  end function

 
 public function GetStaffByStage (stageid as integer) as DataSet
  
 	dim myDataset as new Dataset
	dim myConn As new SQLConnection(ConfigurationSettings.AppSettings("ProjectPalDSN"))
	dim mySQLAdapter as new SQLDataAdapter("spGetStaffByStage", myConn)

	mySQLAdapter.SelectCommand.CommandType = CommandType.StoredProcedure
	
	mySQLAdapter.SelectCommand.Parameters.Add(New SqlParameter("@stageid", SqlDbType.int))
    mySQLAdapter.SelectCommand.Parameters("@stageid").Value = stageid
  	
    mySQLAdapter.Fill(myDataSet, "staff")
	
	Return myDataSet
  
  end function


function Update(staffdata as structStaff) as boolean

	dim myDSN As String = ConfigurationSettings.AppSettings("ProjectPalDSN")
	dim myConn As new SqlConnection(myDSN)
	dim myCommand As SqlCommand
	dim myParm As SqlParameter

try	
	myConn.Open()

	'Project Update
	myCommand = New SqlCommand("spUpdateStaff", myConn)
	myParm = myCommand.Parameters.Add("@staffid", SqlDbType.int)
	myCommand.CommandType = CommandType.StoredProcedure
	myParm.Value =  ctype(staffData.id, integer)

	myParm = myCommand.Parameters.Add("@firstname", SqlDbType.varchar, 50)
	myCommand.CommandType = CommandType.StoredProcedure
	myParm.Value =  ctype(staffData.firstname ,string)

	myParm = myCommand.Parameters.Add("@lastname", SqlDbType.varchar, 50)
	myCommand.CommandType = CommandType.StoredProcedure
	myParm.Value =  ctype(staffData.lastname ,string)

	myParm = myCommand.Parameters.Add("@email", SqlDbType.varchar, 50)
	myCommand.CommandType = CommandType.StoredProcedure
	myParm.Value =  ctype(staffData.email ,string)


	myCommand.ExecuteNonQuery()

catch e as SqlException
	throw e
	
finally
	myConn.Close

end try

return(true)

end function



End Class



public class structStaff

	Public id as Integer ' id of staff member (internal)
	Public firstName As String   ' First Name
    Public lastName As String  ' Last Name
	Public email As String  ' email address
	Public password AS String 'password
    Public isPM As integer  'Is a Project Manager

	Public function toInsertString () as string

		return(	"'" + ctype(firstname, string) +"', '" + _				
					  ctype(lastname, string) +"', '" + _
		  			  ctype(email, string) +"', '" + _
					  ctype(password, string) +"', " + _
					  ctype(ispm, string) )

	end function


 End Class


end namespace



