Option Explicit
Option Strict

Imports System
Imports System.Data
Imports System.Data.SQLClient
Imports System.Configuration
Imports System.Collections



namespace projectPal.bo

Public Class boStage

  public function getStagesByProject(projectid as integer) as dataset
	dim myDataset as new Dataset
	dim myConn As new SQLConnection(ConfigurationSettings.AppSettings("ProjectPalDSN"))
	dim mySQLAdapter as new SQLDataAdapter("spGetStagesbyProject", myConn)

	mySQLAdapter.SelectCommand.CommandType = CommandType.StoredProcedure

	mySQLAdapter.SelectCommand.Parameters.Add(New SqlParameter("@projectid", SqlDbType.varchar))
    mySQLAdapter.SelectCommand.Parameters("@projectid").Value = projectid
  	
    mySQLAdapter.Fill(myDataSet, "stages")
	
	Return myDataSet

  end function


function Update(stagedata as structStage) as boolean

	dim myDSN As String = ConfigurationSettings.AppSettings("ProjectPalDSN")
	dim myConn As new SqlConnection(myDSN)
	dim myCommand As SqlCommand
	dim myParm As SqlParameter

try	
	myConn.Open()

	'Project Update
	myCommand = New SqlCommand("spUpdateStage", myConn)
	myParm = myCommand.Parameters.Add("@stageid", SqlDbType.int)
	myCommand.CommandType = CommandType.StoredProcedure
	myParm.Value =  ctype(stageData.id, integer)

	myParm = myCommand.Parameters.Add("@name", SqlDbType.varchar, 50)
	myCommand.CommandType = CommandType.StoredProcedure
	myParm.Value =  ctype(stageData.name ,string)

	myCommand.ExecuteNonQuery()

catch e as SqlException
	throw e
	
finally
	myConn.Close

end try

return(true)

end function

End Class


 public class structStage
    Public id As Integer ' id of Stage 
    Public name As String  ' Name of Stage 
 End Class


end namespace



